#ifndef BMP_H
#define BMP_H

#include <iostream>

struct BMPFileHeader
{
	BMPFileHeader( long _width, long _height );

	short	magic;
	long	fileSize;
	short	reserved_1;
	short	reserved_2;
	long	dataOffset;	
};

struct BMPInfoHeader
{
	BMPInfoHeader( long _width, long _height );

	unsigned long	headerSize;
	long			width;
	long			height;
	short			colorPlanes;
	short			bitsPerPixel;
	unsigned long	compression;
	unsigned long	imageSize;
	long			horizontalRes;
	long			verticalRes;
	unsigned long	colorCount;
	unsigned long	importantColors;
};

std::ostream& operator<<( std::ostream& _out, const BMPFileHeader& _h );
std::ostream& operator<<( std::ostream& _out, const BMPInfoHeader& _h );

#endif
