#ifndef CONFIGURATION_H
#define CONFIGURATION_H

#include <string>
#include "Real.h"

class Configuration
{
public:

	Configuration();
	Configuration( const std::string& _fileName );

	void			SetDefault();

	int			GetNodeCount()			const;
	Real			GetNodeRadius()			const;
	Real			GetKnowingTime()		const;	// Koli
	Real			GetSimulationTime()		const;
	Real			GetCellDistanceWeight()		const;
	Real			GetNodeSpeedMultiplier()	const;
	Real			GetWaitingTimeExponent()	const;
	Real			GetWaitingTimeUpperBound()	const;

	int			GetBucketCountPerSide()		const;

	bool			IsShowOnlyMeetAndLeaveEnabled() const;
	bool			IsSaveVideoEnabled()		const;
	bool			IsSaveImagesEnabled()		const;
	int			GetVideoFPS()			const;
	Real			GetImageTimeInterval()		const;
	std::string		GetVideoFileName()		const;
	int			GetVideoWidth()			const;
	int			GetVideoHeight()		const;
	bool			IsDrawNodesEnabled()		const;
	bool			IsDrawNodeRadiusEnabled()	const;
	bool			IsDrawCellWeightsEnabled()	const;
	bool			IsDrawBucketsEnabled()		const;
	int			GetTargetNodeID()		const;
	bool			IsDrawGridEnabled()		const;

	bool			IsShowTraceEnabled()		const;
	bool			IsSaveTraceFileEnabled()	const;
	std::string		GetTraceFileName()		const;

	bool			IsShowProgressEnabled()		const;
	int			GetProgressStep()		const;

private:

	int			nodeCount;
	Real			nodeRadius;
	Real			knowingTime;	// Koli
	Real			simulationTime;
	Real			cellDistanceWeight;
	Real			nodeSpeedMultiplier;
	Real			waitingTimeExponent;
	Real			waitingTimeUpperBound;

	int			bucketCountPerSide;

	bool			showOnlyMeetAndLeave;
	bool			saveVideo;
	bool			saveImages;
	int			videoFPS;
	Real			imageTimeInterval;
	std::string		videoFileName;
	int			videoWidth;
	int			videoHeight;
	bool			drawNodes;
	bool			drawNodeRadius;
	bool			drawCellWeights;
	bool			drawBuckets;
	int			targetNodeID;
	bool			drawGrid;

	bool			saveTraceFile;
	std::string		traceFileName;

	bool			showTrace;
	bool			showProgress;
	int			progressStep;
};

#endif
