#ifndef EVENT_H
#define EVENT_H

#include <iostream>
#include "Real.h"
#include "Node.h"

struct Event
{
	enum Type
	{
		INVALID = 0,

		START_MOVING,
		START_WAITING,
		END_MOVING,
		END_WAITING,

		MEET,
		LEAVE,

		IMAGE,
	};

	Event();
	Event( Event::Type _type, Node* _n1, Node* _n2, Real _time );

	bool operator<( const Event& other ) const;

	Type	type;
	
	Node*	firstNode;
	Node*	secondNode;

	Real	time;
	
	Real	getTime();

};

std::ostream& operator<<( std::ostream& _out, const Event& _e );


#endif
