#ifndef IMAGE_H
#define IMAGE_H

#include <string>
#include "Color.h"

class Image
{
public:

	friend class Video;

	Image( int _width, int _height, Color _fillColor = Color( 0, 0, 0 ) );
	Image( const Image& _other );
	~Image();

	int		GetWidth()	const;
	int		GetHeight()	const;

	void	Fill( Color _color );

	void	PutPixel( int _x, int _y, Color _color );
	void	DrawRect( int _startX, int _startY, int _endX, int _endY, Color _color );
	void	DrawHorizontalLine( int _y, Color _color );
	void	DrawVerticalLine( int _x, Color _color );
	void	DrawCircleOutline( int _posX, int _posY, int _radius, Color _color );
	void	DrawCircle( int _posX, int _posY, int _radius, Color _color );

	bool	SaveBMP( const std::string& _fileName );

private:

	int		width;
	int		height;

	unsigned char*	rData;
	unsigned char*	gData;
	unsigned char*	bData;

};

#endif
