#ifndef INTERSECTION_H
#define INTERSECTION_H

#include "Vector2.h"

namespace intersect
{
	inline bool MovingCirclesBoundingBoxTest(
		const Vector2& _startA, const Vector2& _endA, Real _radiusA,
		const Vector2& _startB, const Vector2& _endB, Real _radiusB );

	inline bool BoundingBoxes(
		const Vector2& _minA, const Vector2& _maxA,
		const Vector2& _minB, const Vector2& _maxB );

	bool Circles(
		const Vector2& _posA, Real _radiusA,
		const Vector2& _posB, Real _radiusB );

	bool MovingCircles(
		const Vector2& _startA, const Vector2& _endA, Real _radiusA,
		const Vector2& _startB, const Vector2& _endB, Real _radiusB,
		bool* _enter, bool* _exit, Real* _enterTime, Real* _exitTime );

	bool LineCircle(
		const Vector2& _lineStart, const Vector2& _lineEnd,
		const Vector2& _circlePos, Real _circleRadius,
		bool* _enter, bool* _exit, Vector2* _enterPoint, Vector2* _exitPoint );
}

#include "Intersection.inl"

#endif
