namespace intersect
{
	inline bool MovingCirclesBoundingBoxTest(
		const Vector2& _startA, const Vector2& _endA, Real _radiusA,
		const Vector2& _startB, const Vector2& _endB, Real _radiusB )
	{
		Vector2 minA;
		Vector2 maxA;
		Vector2 minB;
		Vector2 maxB;

		minA.x = std::min( _startA.x, _endA.x ) - _radiusA;
		minA.y = std::min( _startA.y, _endA.y ) - _radiusA;

		maxA.x = std::max( _startA.x, _endA.x ) + _radiusA;
		maxA.y = std::max( _startA.y, _endA.y ) + _radiusA;

		minB.x = std::min( _startB.x, _endB.x ) - _radiusB;
		minB.y = std::min( _startB.y, _endB.y ) - _radiusB;

		maxB.x = std::max( _startB.x, _endB.x ) + _radiusB;
		maxB.y = std::max( _startB.y, _endB.y ) + _radiusB;

		if( ( maxA.x < minB.x ) || ( minA.x > maxB.x ) ||
			( maxA.y < minB.y ) || ( minA.y > maxB.y ) )
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	inline bool BoundingBoxes(
		const Vector2& _minA, const Vector2& _maxA,
		const Vector2& _minB, const Vector2& _maxB )
	{
		if( ( _maxA.x < _minB.x ) || ( _minA.x > _maxB.x ) ||
			( _maxA.y < _minB.y ) || ( _minA.y > _maxB.y ) )
		{
			return false;
		}
		else
		{
			return true;
		}
	}
}
