#include <iostream>
#include <exception>
#include "Random.h"
#include "Simulation.h"

// #include "Gaussian.h"

int main( int argc, char* argv[] )
{
	std::string configFileName = "config.txt";

	if( argc > 2 )
	{
		std::cerr << "usage: " << argv[ 0 ] << " [config_file_name]" << std::endl;
		return 0;
	}
	else if( argc == 2 )
	{
		configFileName = argv[ 1 ];
	}

	try
	{
		random_generator::Init();
		Configuration config( configFileName );

		/* create network */
		

		Network network( config );
		
		for( int i = 0; i < config.GetNodeCount(); ++i )
		{
			network.AddNode( random_generator::GetReal(), random_generator::GetReal(), config.GetNodeCount() );
		}

	
		network.InitNodes();

		// start simulation

		Simulation simulation( network, config );
		simulation.Start();
	}
	catch( const std::exception& e )
	{
		std::cerr << "exception thrown" << std::endl;
		std::cerr << e.what() << std::endl;
		return 0;
	}

	return 0;
}
