#include <algorithm>
#include "NodeCheckList.h"
#include "Node.h"

static bool nodeComp( Node* n1, Node* n2 )
{
	return n1->GetID() < n2->GetID();
}

NodeCheckList::NodeCheckList( int _totalNodeCount )
{
	nodes = new Node*[ _totalNodeCount ];
	nodeTaken = new bool[ _totalNodeCount ];
	nodeCount = 0;
	totalNodeCount = _totalNodeCount;

	Reset();
}

NodeCheckList::~NodeCheckList()
{
	delete[] nodeTaken;
	delete[] nodes;
}

void NodeCheckList::Reset()
{
	nodeCount = 0;
	for( int i = 0; i < totalNodeCount; ++i )
	{
		nodeTaken[ i ] = false;
	}
}

void NodeCheckList::ExcludeNode( Node* _node )
{
	nodeTaken[ _node->GetID() ] = true;
}

void NodeCheckList::AddNodes( std::set< Node* >& _bucket )
{
	std::set< Node* >::iterator itor = _bucket.begin();
	for( ; itor != _bucket.end(); ++itor )
	{
		if( nodeTaken[ ( *itor )->GetID() ] == false )
		{
			nodes[ nodeCount++ ] = ( *itor );
			nodeTaken[ ( *itor )->GetID() ] = true;
		}
	}
}

void NodeCheckList::Sort()
{
	std::sort( &nodes[ 0 ], &nodes[ nodeCount ], nodeComp );
}
