#ifndef NODECHECKLIST_H
#define NODECHECKLIST_H

#include <set>

class Node;

class NodeCheckList
{
public:

	NodeCheckList( int _totalNodeCount );
	~NodeCheckList();

	void		Reset();	
	void		ExcludeNode( Node* _node );
	void		AddNodes( std::set< Node* >& _bucket );

	void		Sort();

	inline size_t GetNodeCount()
	{
		return nodeCount;
	}

	inline Node* GetNode( size_t i )
	{
		return nodes[ i ];
	}

private:

	Node**		nodes;
	bool*		nodeTaken;
	int			nodeCount;			// nodes in the check list
	int			totalNodeCount;		// nodes in the network
};

#endif
