#ifndef VIDEO_H
#define VIDEO_H

#include <vector>
#include "Image.h"

class Video
{
public:

	Video( int _width, int _height, int _framesPerSecond );
	~Video();

	size_t	GetFrameCount() const;
	Image*	GetFrame( size_t _index );

	bool	AddFrame( Image* _frame );
	Image*	CreateFrame( Color _fillColor = Color( 0, 0, 0 ) );

	bool	SaveAVI( const std::string& _fileName ) const;

private:

	int		width;
	int		height;
	int		framesPerSecond;

	std::vector< Image* >	frames;
	
};

#endif
